> ## Documentation Index
> Fetch the complete documentation index at: https://docs.immutable.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Link wallet v2

> Link an external EOA wallet to an Immutable Passport account by providing an EIP-712 signature.



## OpenAPI

````yaml https://imx-openapiv3-mr-sandbox.s3.us-east-2.amazonaws.com/openapi.json post /passport-profile/v2/linked-wallets
openapi: 3.0.3
info:
  title: Immutable zkEVM API
  version: 1.0.0
  description: Immutable Multi Rollup API
  contact:
    name: Immutable API Support
    email: support@immutable.com
    url: https://support.immutable.com
servers:
  - url: https://api.sandbox.immutable.com
security: []
tags:
  - name: activities
    description: Activities Endpoints
    x-displayName: activities
  - name: chains
    description: Chains Endpoints
    x-displayName: chains
  - name: collections
    description: Collections Endpoints
    x-displayName: collections
  - name: nfts
    description: NFTs Endpoints
    x-displayName: nfts
  - name: nft owners
    description: NFT Owner Endpoints
    x-displayName: nft owners
  - name: metadata
    description: NFT Metadata Endpoints
    x-displayName: metadata
  - name: tokens
    description: ERC20 Token Endpoints
    x-displayName: tokens
  - name: demopage
    description: Temporary HTML endpoint for demo purposes
    x-displayName: demopage
  - name: verification
    x-displayName: verification
  - name: operatorallowlist
    x-displayName: operatorallowlist
  - name: crafting
    x-displayName: crafting
  - name: listings
    description: Listings Endpoints
    x-displayName: listings
  - name: orders
    x-displayName: orders
  - name: passport
    description: Passport operations
    x-displayName: passport
  - name: gamefi
    description: team gamefi
    x-displayName: gamefi
  - name: health
    x-displayName: health
  - name: passport profile
    description: Passport Profile endpoints
    x-displayName: passport profile
  - name: feed-items
    x-displayName: feed-items
  - name: assets
    x-displayName: assets
  - name: guardian
    description: Guardian endpoints
    x-displayName: guardian
  - name: pricing
    description: Pricing Endpoints
    x-displayName: pricing
  - name: metadata-search
    x-displayName: metadata-search
paths:
  /passport-profile/v2/linked-wallets:
    post:
      tags:
        - passport profile
      summary: Link wallet v2
      description: >-
        Link an external EOA wallet to an Immutable Passport account by
        providing an EIP-712 signature.
      operationId: link-wallet-v2
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/LinkWalletV2Request'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/Wallet'
        '400':
          description: BadRequestError
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/APIError400'
        '401':
          description: UnauthorizedError
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/APIError401'
        '403':
          description: ForbiddenError
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/APIError403'
        '500':
          description: InternalServerError
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/APIError500'
      security:
        - BearerAuth:
            - openid
components:
  schemas:
    LinkWalletV2Request:
      description: Link wallet V2 request
      type: object
      required:
        - type
        - wallet_address
        - signature
        - nonce
      properties:
        type:
          type: string
          description: >-
            This should be the EIP-6963 rdns value, if you're unable to get the
            rdns value you can provide "External". If using WalletConnect then
            provide "WalletConnect".
          example: io.metamask
          maxLength: 32
          not:
            enum:
              - Passport
              - com.immutable.passport
        wallet_address:
          description: The address of the external wallet being linked to Passport
          type: string
          example: '0xd8da6bf26964af9d7eed9e03e53415d37aa96045'
          pattern: ^0x[a-fA-F0-9]{40}$
        signature:
          description: The EIP-712 signature
          type: string
        nonce:
          description: A unique identifier for the signature
          type: string
    Wallet:
      description: Linked wallet
      type: object
      required:
        - address
        - type
        - created_at
        - updated_at
        - clientName
      properties:
        address:
          $ref: '#/components/schemas/EthAddress'
        type:
          $ref: '#/components/schemas/WalletType'
        created_at:
          $ref: '#/components/schemas/CreatedAt'
        updated_at:
          $ref: '#/components/schemas/CreatedAt'
        name:
          $ref: '#/components/schemas/Name'
        clientName:
          type: string
          description: Name of client that linked the wallet
          example: Passport Dashboard
    APIError400:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - VALIDATION_ERROR
              example: VALIDATION_ERROR
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError401:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - UNAUTHORISED_REQUEST
              example: UNAUTHORISED_REQUEST
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError403:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - AUTHENTICATION_ERROR
              example: AUTHENTICATION_ERROR
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError500:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - INTERNAL_SERVER_ERROR
              example: INTERNAL_SERVER_ERROR
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    EthAddress:
      description: Ethereum address
      type: string
      example: '0xd8da6bf26964af9d7eed9e03e53415d37aa96045'
    WalletType:
      description: Wallet type
      type: string
      example: MetaMask
    CreatedAt:
      description: Created at
      type: string
      format: date-time
      example: '2021-08-31T00:00:00Z'
    Name:
      description: Name
      type: string
      example: Test
    BasicAPIError:
      type: object
      properties:
        message:
          type: string
          description: Error Message
          example: all fields must be provided
        link:
          type: string
          description: Link to IMX documentation that can help resolve this error
          example: https://docs.x.immutable.com/reference/#/
        trace_id:
          type: string
          description: Trace ID of the initial request
          example: e47634b79a5cd6894ddc9639ec4aad26
      required:
        - message
        - link
        - trace_id
  securitySchemes:
    BearerAuth:
      type: http
      scheme: bearer
      bearerFormat: JWT

````